--[[ 
          					 Flash a file using Lua example + Lua Player Mod
          					 
                      						        By SG57
  			 "you'll never know what it's like... spending your whole life in a dream..." 


		 						I take 0 responsibility for your actions with this new found power.
		 But, bricking completely is almost impossible with all the custom firmware versions out there
		
		
					Flashing a file is just a bit more difficult than writing a file to the memory stick.
				This is because, the flash device/drivers are, by default, in a 'read-only' mode.
		
		To get by this little problem, we need to unassign our flash devices/drivers, and reassign
												them WITH writing permission.
]]

green = Color.new(0,255,0)
magenta = Color.new(255,0,255)
white = Color.new(255,255,255)
red = Color.new(255,0,0)
blue = Color.new(0,0,255)
yellow = Color.new(255,255,0)

function PrintCentered(y,string,color)
     screen:print( 240 - (string.len(string)*8) / 2 ,y,string,color);
end

-- Basic stuff... all these front clears and flips are to clear any lowser residue :S

screen.flip()
screen:clear()
screen.waitVblankStart()
screen.flip()
screen.waitVblankStart()
screen.flip()

PrintCentered(20,"Flashing a file in Lua",green)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(30,"By SG57",magenta)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(90,"This will flash the file 'ms0:/01-12.bmp'",white)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(100,"to 'flash0:/vsh/resource/', but will first make a backup.",white)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(110,"This is mainly for demonstration purposes only",white)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(120,"so many other flashing applications may be produced.",white)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(160,"Unassigning 'flash0:'...",red)
screen.waitVblankStart()
screen.flip()

-- start flash unassignment

	-- Ok, by default, the flash devices/drivers are set to 'read-only', meaning if you just wanted
	--     to grab something off flash, as a dumper or something, than there is no need for these
	--     2 assignments
	System.Unassign("flash0:") -- unassign the device/driver flash0 (can be flash1, ms0, disc0, etc.)

-- end flash unassignment
screen.flip()
PrintCentered(170,"Done!",yellow)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

screen.flip()
PrintCentered(190,"Re-assigning 'flash0:', but with read-write privelages...",red)
screen.waitVblankStart()
screen.flip()

-- start flash assignment

	-- Here, we are re-assigning the flash device/driver 'flash0' so that it may have read and write
	--      privelages.  It may not look it, but it's programmed to do it for you ;-)
	System.Assign("flash0:", "lflash0:0,0", "flashfat0:") -- this assigns 'flash0' as the flash0 device/driver id/name; it can be flash2:,flash3:,sg57_is_cool:,etc.
-- end flash assignment

screen.flip()
PrintCentered(200,"Done!",yellow)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)

-- here, we will first backup the current 01-12.bmp
screen.flip()
PrintCentered(220,"Backing up current flash0:/vsh/resource/01-12.bmp to ms0:/",red)
screen.waitVblankStart()
screen.flip()

-- The parameters are:
--    src - The file you wish to read from, so it may be written in another file
--    dest - The file you wish to create, as a copy of the src file (note, automatically overwritten if present)
--    remove - a flag determining whether or not you want to remove the src file after writing it to dest ("yes" if so, else anything for no)
System.writeFile("flash0:/vsh/resource/01-12.bmp","ms0:/01-12.bmp.backup","no")

screen.flip()
PrintCentered(230,"Done!",yellow)
screen.waitVblankStart()
screen.flip()

screen.waitVblankStart(120)
screen.flip()

PrintCentered(250,"Press [X] to flash ms0:/01-12.bmp to flash0:/vsh/resource/",blue)
PrintCentered(260,"*NOTE* Checks are ran to minimize chance of bricking *NOTE*",red)
screen.waitVblankStart()
screen.flip()

Pressed = {cross=false}  

while true do
	
	pad = Controls.read()
	
	if pad:cross() then
		if not Pressed.cross then
			
			-- this line is saying to write the file in the first argument, to the second, overwriting if necessary
			-- the third argument is saying to delete the src file, aka ms0:/01-12.bmp
			System.writeFile("ms0:/01-12.bmp","flash0:/vsh/resource/01-12.bmp","yes")
			
			-- ok.. the following is garbage =-S  i was sick of the lowser appearing in the background when doin
			--  this part, so i just threw a bunch of screen clears, flips and Vblanks...
			screen.flip()
			screen:clear()
			screen.waitVblankStart()
			screen.flip()
			screen.waitVblankStart()
			screen.flip()
			PrintCentered(131,"I don't know how to tell you this...",red) 
      screen.flip()
      screen.waitVblankStart()
			screen:clear()
			screen.waitVblankStart()
			screen.flip()
			screen.waitVblankStart()
			screen.flip()
			screen.waitVblankStart(300)
			PrintCentered(131,"So I won't beat around the bush...",red) 
      screen.flip()
      screen.waitVblankStart()
			screen:clear()
			screen.waitVblankStart()
			screen.flip()
			screen.waitVblankStart()
			screen.flip()
			screen.waitVblankStart(300)
      screen.flip()
			time = 0
			pi = math.atan(1) * 4
			while true do
				screen:clear()
				y = math.sin(pi * 2 / 360 * time*7) * 100 + 131
				PrintCentered(y,"It worked!", Color.new(math.random(0,255),math.random(0,255),math.random(0,255)))
				time = time + 1
				if time >= 360 then time = 0 end
			 
				screen.waitVblankStart()
				screen.flip()
			 
				pad = Controls.read()
				if pad:start() then
					break
				end
			end
      break
		end
	else Pressed.cross = false end
end